# Standard libraries
using Dates
using Printf
using Random

# External libraries
using CPLEX
using Distributions
using JuMP
using LinearAlgebra

version() = "v1.0"
author() = "Theo Guyard"
contact() = "theo.guyard@insa-rennes.fr"
license() = "MIT License (https://mit-license.org)"

# Module files
include("types.jl")
include("activeset.jl")
include("bnb.jl")
include("bvls.jl")
include("data.jl")
include("displays.jl")
include("mips.jl")
include("screen.jl")