include("../src/BnbScreening.jl")

k, m, n, snr = 5, 500, 300, 10*log10(10)
A, y, λ, M = data_toeplitz(k,m,n,snr)
#k, m, n, snr = 5, 500, 1000, 10*log10(10)
#A, y, λ, M = data_gaussian(k,m,n,snr)

result_mip = solve_mip(A,y,λ,M)
println("MIP")
println("  Status    : $(result_mip.termination_status)")
println("  Objective : $(result_mip.objective_value)")
println("  Nodes     : $(result_mip.node_count)")
println("  Timer     : $(result_mip.solve_time)")

result_bnb = solve_bnb(A,y,λ,M,bnbparams=BnbParams(verbosity=false))
println("BnB")
println("  Status    : $(result_bnb.termination_status)")
println("  Objective : $(result_bnb.objective_value)")
println("  Nodes     : $(result_bnb.node_count)")
println("  Timer     : $(result_bnb.solve_time)")
println("Error : $(abs(result_mip.objective_value - result_bnb.objective_value))")

result_bnb_scr = solve_bnb(A,y,λ,M,bnbparams=BnbParams(verbosity=false,screening=true))
println("BnB + scr")
println("  Status    : $(result_bnb_scr.termination_status)")
println("  Objective : $(result_bnb_scr.objective_value)")
println("  Nodes     : $(result_bnb_scr.node_count)")
println("  Timer     : $(result_bnb_scr.solve_time)")
println("  Scr-0     : $(result_bnb_scr.scr0)")
println("  Scr-1     : $(result_bnb_scr.scr1)")
println("Error : $(abs(result_mip.objective_value - result_bnb_scr.objective_value))")